/******************************************************************************
 * Copyright 2001,2002,2003:  {{{ 
 *
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be) }}}
 *****************************************************************************/
/*!\addtogroup ARM_BACKEND */
/*@{ */
#include "../../config.h"
#ifndef _ARM_ASSEMBLE_ONE_H
#define _ARM_ASSEMBLE_ONE_H
void ArmAssembleBranch(t_ins * ins, t_uint32 * instr);
void ArmAssembleSwap(t_ins * ins, t_uint32 * instr);
void ArmAssembleDataProc(t_ins * ins, t_uint32 * instr);
void ArmAssembleSWI(t_ins * ins, t_uint32 * instr);
void ArmAssembleMUL(t_ins * ins, t_uint32 * instr);
void ArmAssembleStatus(t_ins * ins, t_uint32 * instr);
void ArmAssembleFLTStatus(t_ins * ins, t_uint32 * instr);
void ArmAssembleFLTCPDO(t_ins * ins,t_uint32 * instr);
void ArmAssembleFLTMEM(t_ins * ins, t_uint32 * instr);
void ArmAssembleLoad(t_ins * ins, t_uint32 * instr);
void ArmAssembleStore(t_ins * ins, t_uint32 * instr);
void ArmAssembleMultipleTransfer(t_ins * ins, t_uint32 * instr);
#endif
/*@}*/
/* vim: set shiftwidth=2 foldmethod=marker: */
