/******************************************************************************
 * Copyright 2001,2002,2003:  {{{ 
 *
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be) }}}
 *****************************************************************************/

/*!\addtogroup ARM_BACKEND */
/*@{ */
#include "../../config.h"

#ifndef ARM_REGISTERS_H
#define ARM_REGISTERS_H
/* Includes {{{ */
#include "../../datastructures/data_string.h"
#include "../../kernel/diablo_regset.h"
/* }}} */
t_string ArmRegisterName(t_reg reg);
/* The arm registers */
/* \todo document */
#define ARM_REG_NONE       255
/* \todo document */
#define ARM_REG_R0           0
/* \todo document */
#define ARM_REG_R1           1
/* \todo document */
#define ARM_REG_R2           2
/* \todo document */
#define ARM_REG_R3           3
/* \todo document */
#define ARM_REG_R4           4
/* \todo document */
#define ARM_REG_R5           5
/* \todo document */
#define ARM_REG_R6           6
/* \todo document */
#define ARM_REG_R7           7
/* \todo document */
#define ARM_REG_R8           8
/* \todo document */
#define ARM_REG_R9           9
/* \todo document */
#define ARM_REG_R10         10
/* \todo document */
#define ARM_REG_R11         11
/* \todo document */
#define ARM_REG_R12         12
/* \todo document */
#define ARM_REG_R13         13
/* \todo document */
#define ARM_REG_R14         14
/* \todo document */
#define ARM_REG_R15         15
/* \todo document */
#define ARM_REG_CPSR        16
/* \todo document */
#define ARM_REG_SPSR        17
/* \todo document */
#define ARM_REG_Q_CONDITION 18
/* \todo document */
#define ARM_REG_C_CONDITION 19
/* \todo document */
#define ARM_REG_V_CONDITION 20 
/* \todo document */
#define ARM_REG_Z_CONDITION 21 
/* \todo document */
#define ARM_REG_N_CONDITION 22 
/* \todo document */
#define ARM_REG_F0          23
/* \todo document */
#define ARM_REG_F1          24
/* \todo document */
#define ARM_REG_F2          25
/* \todo document */
#define ARM_REG_F3          26
/* \todo document */
#define ARM_REG_F4          27
/* \todo document */
#define ARM_REG_F5          28
/* \todo document */
#define ARM_REG_F6          29
/* \todo document */
#define ARM_REG_F7          30
/* \todo document */
#define ARM_REG_FPSR        31
#endif
/*@}*/
/* vim: set shiftwidth=2 foldmethod=marker: */
