#include "../../config.h"

#ifndef THUMB_DISASSEMBLE_ONE_H
#define THUMB_DISASSEMBLE_ONE_H
/* Includes {{{ */
#include "../../kernel/diablo_ins.h"
/* }}} */

void ThumbDisassembleCondBranch(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleBranchLink(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleBranch(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleSWI(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassemble3Bit(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleImm(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleShifted(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleALU(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleHiReg(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleLoadAddress(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleStack(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleTransferImm(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleTransferHalf(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleTransferSign(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleTransferRegOff(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleTransferPC(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleTransferSP(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleMultipleTransfer(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassemblePP(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleUnsupported(t_ins * ins, t_uint32 instr, t_uint16 opc);
void ThumbDisassembleData(t_ins * ins, t_uint32 instr, t_uint16 opc);

#endif
/* vim: set shiftwidth=2 foldmethod=marker : */
