/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#include "i386_instructions.h"
#include "i386_table.h"

t_bool I386OpCheckNone(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckReg(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckST(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckConst1(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckA(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckC(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckD(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckE(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckF(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckG(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpChecksI(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckI(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpChecksI2(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckI2(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckJ(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckM(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckO(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckR(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckS(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckX(t_i386_operand * op, t_i386_bytemode bm);
t_bool I386OpCheckY(t_i386_operand * op, t_i386_bytemode bm);
/* vim: set shiftwidth=2 foldmethod=marker: */
