/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */

#ifndef I386_OPPOSITE_H
#define I386_OPPOSITE_H
typedef struct _t_i386_opposite t_i386_opposite;
#include "i386_opcode.h"

t_bool OppositeCondExist(t_uint32 test_opcode);
t_uint32 GiveOppositeCondition(t_uint32 test_opcode);
t_bool OppositeExist(t_bbl * i_bbl);
t_bool MakeOpposite(t_bbl * i_bbl);
  
struct _t_i386_opposite
{
  t_uint32 cond0;
  t_uint32 cond1;
};

#endif
/* vim: set shiftwidth=2: */
