/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../../config.h"
#ifndef IA64_ASSEMBLE_ONE_I_H
#define IA64_ASSEMBLE_ONE_I_H

#include "../../../kernel/diablo_ins.h"
#include "../ia64_bundle.h"
#include "../ia64_assemble.h"

void Ia64AssembleI1(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI2(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI3(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI4(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI5(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI6(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI7(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI8(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI9(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI10(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI11(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI12(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI13(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI14(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI15(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI16(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI17(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI18(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI19(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI20(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI21(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI22(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI23(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI24(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI25(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI26(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI27(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI28(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleI29(t_ins * ins, t_uint64 * instr, t_bundle * bundle);


#endif
/* vim: set shiftwidth=2: */
