/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef IA64_BRANCH_H
#define IA64_BRANCH_H

#include "../../datastructures/data_graph.h"
#include "../../kernel/diablo_bbl.h"
#include "../../kernel/diablo_object.h"
#include "../../utils/util_error.h"
#include "ia64_instructions.h"
#include "ia64_opcodes.h"
#include "ia64_disassemble.h"
#include "ia64_prograph.h"

void Ia64AdaptBranch(t_cfg * cfg);
void Ia64AdaptFallthrough(t_cfg * cfg);
#endif
/* vim: set shiftwidth=2: */
