/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../../config.h"
#ifndef IA64_DISASSEMBLE_ONE_A_H
#define IA64_DISASSEMBLE_ONE_A_H

#include "../../../kernel/diablo_ins.h"
#include "../ia64_bundle.h"
#include "../ia64_disassemble.h"

void Ia64DisassembleA1(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleA2(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleA3(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleA4(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleA5(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleA6(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleA7(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleA8(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleA9(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleA10(t_ins * ins, t_uint64 instr, t_bundle *bundle);

#endif
/* vim: set shiftwidth=2: */
