/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../../config.h"
#ifndef IA64_UTILS_B_H
#define IA64_UTILS_B_H

#include "../../../kernel/diablo_regset.h"
#include "../../../kernel/diablo_ins.h"

void Ia64UsedRegistersB1(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersB2(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersB3(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersB4(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersB5(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersB6(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersB7(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersB8(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersB9(t_regset * mask, t_ins * ins);


void Ia64DefinedRegistersB1(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersB2(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersB3(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersB4(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersB5(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersB6(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersB7(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersB8(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersB9(t_regset * mask, t_ins * ins);
#endif
/* vim: set shiftwidth=2: */
