/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../../config.h"
#ifndef IA64_UTILS_I_H
#define IA64_UTILS_I_H

#include "../../../kernel/diablo_regset.h"
#include "../../../kernel/diablo_ins.h"

void Ia64UsedRegistersI1(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI2(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI3(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI4(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI5(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI6(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI7(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI8(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI9(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI10(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI11(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI12(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI13(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI14(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI15(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI16(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI17(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI18(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI19(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI20(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI21(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI22(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI23(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI24(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI25(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI26(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI27(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI28(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersI29(t_regset * mask, t_ins * ins);

void Ia64DefinedRegistersI1(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI2(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI3(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI4(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI5(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI6(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI7(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI8(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI9(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI10(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI11(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI12(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI13(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI14(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI15(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI16(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI17(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI18(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI19(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI20(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI21(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI22(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI23(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI24(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI25(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI26(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI27(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI28(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersI29(t_regset * mask, t_ins * ins);

#endif
/* vim: set shiftwidth=2: */
