/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef MY_AIF_H
#define MY_AIF_H
#include "../../simple_types.h"
#include "../../kernel/diablo_object.h"
typedef struct 
{
/*00:*/	char Decompress[4];
/*04:*/	char SelfReloc[4];
/*08:*/ char DZInit[4];
/*0C:*/	char EntryPoint[4];
/*10:*/ char ExitInst[4];
/*14:*/	char ROSize[4];
/*18:*/	char RWSize[4]; 
/*1C:*/ char DBSize[4];
/*20:*/ char ZISize[4];
/*24:*/ char DBType[4];
/*28:*/ char Base[4];
/*2C:*/ char WorkSpace[4];
/*30:*/ char AdressMode[4]; 
/*34:*/ char DataBase[4]; 
/*38:*/ char pad1[8]; 
/*40:*/ char DBInstr[4];
/*44:*/ char pad2[60]; 

} AIF_HDR;
void ReadAif(FILE * fp, t_object * obj);
t_bool IsAif(FILE * fp);
#endif
