/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *//* This file contains all values that are specific for arm-elf formats */

#ifndef MY_ARMELF_H
#define MY_ARMELF_H
#define EF_ARM_HASENTRY          0x2
#define EF_ARM_SYMSARESORTED     0x4
#define EF_ARM_DYNSYMSUSESEGIDX  0x8
#define EF_ARM_MAPSYMSFIRST      0x10
#define EF_ARM_EABIMASK          0xff000000


#define R_ARM_NONE       0
#define R_ARM_PC24       1
#define R_ARM_ABS32      2
#define R_ARM_REL32      3
#define R_ARM_PC13       4
#define R_ARM_ABS16      5
#define R_ARM_ABS12      6
#define R_ARM_THM_ABS5   7
#define R_ARM_ABS8       8
#define R_ARM_SBREL32    9
#define R_ARM_THM_PC22   10
#define R_ARM_THM_PC8    11
#define R_ARM_AMP_VCALL9 12
#define R_ARM_SWI24      13
#define R_ARM_THM_SWI8   14
#define R_ARM_XPC25      15
#define R_ARM_THM_XPC22  16
#define R_ARM_GOTOFF     24
#define R_ARM_GOTPC      25
#define R_ARM_GOT32	 26
#define R_ARM_PLT32	 27
#endif
