/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#ifndef _ELF_COMMON32_H_
#define _ELF_COMMON32_H_

#include "elf_main.h"

void ElfWriteCommonSameEndian(FILE * fp, Elf32_Ehdr * hdr, t_object * obj, int pagesize);
void ElfReadCommon32(FILE * fp, void * hdr, t_object * obj, Elf32_Shdr ** shdr_ret, Elf32_Sym ** symbol_table_ret, int * numsyms_ret, char ** strtab_ret, char ** sechdrstrtab_ret, t_section *** sec_ret, t_symbol *** lookup, t_bool switch_endian);
#endif
