#ifndef DIABLO_PROGRAM_EXIT_T
#define DIABLO_PROGRAM_EXIT_T
typedef struct _t_cfg_exits t_cfg_exits;
#endif

#ifndef DIABLO_PROGRAM_EXIT_H
#define DIABLO_PROGRAM_EXIT_H
#include "diablo_flowgraph.h"

struct _t_cfg_exits
{
  t_bbl * exit_bbl;
  t_ins * exit_ins;
  /* TRUE if we're certain, FALSE if it's a syscall that might be exit but we're not sure */
  t_bool certain;
  void * tmp;
  struct _t_cfg_exits * next;
};


void CfgCreateExitBlockList(t_cfg * cfg);
void CfgFreeExitBlockList(t_cfg * cfg);
#endif
