/***********************************************************
 * Copyright 2001,2002,2003:  {{{
 *
 * Bruno De Bus
 * Bjorn De Sutter
 * Dominique Chanet
 * Ludo Van Put
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 * MAINTAINER: Bruno De Bus (bdebus@elis.rug.ac.be)  }}}
 ***********************************************************/
/*! \defgroup LAYOUT */
/*@{ */
#ifndef DIABLO_LAYOUT_H
#define DIABLO_LAYOUT_H
/* Includes {{{ */
#include "../simple_types.h"
#include "../datastructures/data_hash.h"
#include "../datastructures/data_graph.h"
#include "diablo_object.h"
#include "diablo_function.h"
#include "diablo_edge.h"
#include "diablo_bbl.h"
#include "diablo_reloc.h"
/*}}}*/

#define SF_MARKED	1
#define SF_PLACED	2

void PlaceSections(t_object * obj,t_bool min);
void MoveSections(t_object * obj);
#endif
/*@}*/
/* vim: set shiftwidth=2 foldmethod=marker: */
