#include "diablo_options.h"
t_option option_list[]={
{0,1,NULL,"ale","annotate_loops",NULL,OPTION_BOOL,&global_options.annotate_loops_set, (void **) &global_options.annotate_loops,{(char *) 0},"Annotate Edges with information about entry in and exit from Loops"},
{0,1,NULL,"pdl","print_data_layout",NULL,OPTION_BOOL,&global_options.print_data_layout_set, (void **) &global_options.print_data_layout,{(char *) 0},"print layout of data apply loop invariant code motion"},
{0,0,"Profile","pi","insprofilefile",NULL,OPTION_STRING,&global_options.insprofilefile_set, (void **) &global_options.insprofilefile,{NULL},"Name of the file containing the instruction execution counts"},
{0,0,"Profile","pb","blockprofilefile",NULL,OPTION_STRING,&global_options.blockprofilefile_set, (void **) &global_options.blockprofilefile,{NULL},"Name of the file containing the basic block execution counts"},
{0,0,NULL,"h","help",NULL,OPTION_USAGE,NULL, (void **) NULL,{NULL},"Print this help message"},
{0,1,NULL,"A","args",NULL,OPTION_STRING,&global_options.arguments_set, (void **) &global_options.arguments,{NULL},"Arguments for an exec"},
{0,0,"Profile guided optimization","licm","loop_invariant_code_motion",NULL,OPTION_BOOL,&global_options.loop_invariant_code_motion_set, (void **) &global_options.loop_invariant_code_motion,{(char *) 0},"apply loop invariant code motion"},
{0,0,"Profile guided optimization","pre","partial_redundancy_elimination",NULL,OPTION_BOOL,&global_options.pre_set, (void **) &global_options.pre,{(char *) 0},"apply partial redundancy elimination"},
{0,0,NULL,"cc","rely_on_calling_conventions",NULL,OPTION_BOOL,&global_options.rely_on_calling_conventions_set, (void **) &global_options.rely_on_calling_conventions,{(char *) 1},"rely on calling conventions during first optimization phases"},
{0,1,NULL,"e","exec",NULL,OPTION_BOOL,&global_options.exec_set, (void **) &global_options.exec,{(char *) 0},"Execute the obtained binary"},
{0,1,NULL,"wm","watermark",NULL,OPTION_STRING,&global_options.watermark_set, (void **) &global_options.watermark,{"none"},"Add a watermark to the program"},
{0,1,NULL,"sF","stegoFile",NULL,OPTION_STRING,&global_options.stegoFile_set, (void **) &global_options.stegoFile,{""},"File to write or read by steganography"},
{0,1,NULL,"sD","stegoDecode",NULL,OPTION_BOOL,&global_options.stegoDecode_set, (void **) &global_options.stegoDecode,{(char *) 0},"Extract hidden information from binary"},
{0,1,NULL,"sE","stegoEncode",NULL,OPTION_BOOL,&global_options.stegoEncode_set, (void **) &global_options.stegoEncode,{(char *) 0},"Hide information in produced binary"},
{0,1,NULL,"rS","restoreState",NULL,OPTION_BOOL,&global_options.restoreState_set, (void **) &global_options.restoreState,{(char *) 0},"Use information of previous run of Diablo"},
{0,1,NULL,"sS","saveState",NULL,OPTION_BOOL,&global_options.saveState_set, (void **) &global_options.saveState,{(char *) 0},"Include information to enable a next run off Diablo"},
{0,1,NULL,NULL,"prepend",NULL,OPTION_STRING,&global_options.prepend_set, (void **) &global_options.prepend,{""},"Prepends a string before all file names"},
{0,1,NULL,"Pft","profile_fallthrough",NULL,OPTION_BOOL,&global_options.fallthrough_set, (void **) &global_options.fallthrough,{(char *) 0},"Turn profile-guided fallthrough adaption for the IA-64 on or off"},
{0,1,NULL,"Pfg","profile_graph",NULL,OPTION_BOOL,&global_options.figure_set, (void **) &global_options.figure,{(char *) 0},"Turn profile-guided dot creation for the IA-64 on or off"},
{0,1,NULL,"Pbw","branch_whether_hints",NULL,OPTION_BOOL,&global_options.bwh_set, (void **) &global_options.bwh,{(char *) 0},"Turn profile-guided branch whether hint optimization for the IA-64 on or off"},
{0,1,NULL,"Ppl","profile_guided_placement",NULL,OPTION_BOOL,&global_options.placement_set, (void **) &global_options.placement,{(char *) 0},"Turn profile-guided placement for the IA-64 on or off"},
{0,1,NULL,"Pu","profile_usage",NULL,OPTION_BOOL,&global_options.useprofile_set, (void **) &global_options.useprofile,{(char *) 0},"Turn profile usage for the IA-64 on or off"},
{0,1,NULL,"Pc","profile_creation",NULL,OPTION_BOOL,&global_options.makeprofile_set, (void **) &global_options.makeprofile,{(char *) 0},"Turn profile creation for the IA-64 on or off"},
{0,1,"Optimization and analysis","Ogp","global_pointer",NULL,OPTION_BOOL,&global_options.gpusage_set, (void **) &global_options.gpusage,{(char *) 0},"Turn global pointer optimization for the IA-64 on or off"},
{0,1,"Optimization and analysis","Obr2","branchregisters2",NULL,OPTION_BOOL,&global_options.branchregs2_set, (void **) &global_options.branchregs2,{(char *) 0},"Turn improved branchregisters optimization for the IA-64 on or off"},
{0,1,"Optimization and analysis","Obr","branchregisters",NULL,OPTION_BOOL,&global_options.branchregs_set, (void **) &global_options.branchregs,{(char *) 0},"Turn branchregisters optimization for the IA-64 on or off"},
{0,1,NULL,"Sn","nopscheduler",NULL,OPTION_BOOL,&global_options.nopscheduler_set, (void **) &global_options.nopscheduler,{(char *) 0},"Turn nop scheduler for the IA-64 on or off"},
{0,1,NULL,"Sl","listscheduler",NULL,OPTION_BOOL,&global_options.listscheduler_set, (void **) &global_options.listscheduler,{(char *) 0},"Turn list scheduler for the IA-64 on or off"},
{0,1,NULL,"Sg","globalscheduler",NULL,OPTION_BOOL,&global_options.globalscheduler_set, (void **) &global_options.globalscheduler,{(char *) 0},"Turn global scheduler for the IA-64 on or off"},
{0,0,NULL,"B","merge bbls",NULL,OPTION_BOOL,&global_options.mergebbls_set, (void **) &global_options.mergebbls,{(char *) 1},"Turn merging of bbls on or off"},
{0,1,NULL,"G","gui-output",NULL,OPTION_BOOL,&global_options.gui_output_set, (void **) &global_options.gui_output,{(char *) 0},"Turn output of CP and liveness information for use in GUI graph viewer on or off"},
{0,1,NULL,"t","traceadr",NULL,OPTION_INT,&global_options.traceadr_set, (void **) &global_options.traceadr,{(char *) 0},"trace address, if given, a bbl at this address is traced"},
{0,1,NULL,"c","debugcount",NULL,OPTION_INT,&global_options.debugcounter_set, (void **) &global_options.debugcounter,{(char *) 0},"debug counter. only useful for debugging diablo's own analyses"},
{0,0,"Debug","v","verbose",NULL,OPTION_COUNT,&global_options.verbose_set, (void **) &global_options.verbose,{(char *) 0},"selects verbose execution (Increases verbose-level, can be used multiple times)"},
{0,0,"Phase control","Z","optimize",NULL,OPTION_BOOL,&global_options.optimize_set, (void **) &global_options.optimize,{(char *) 1},"Turn optimization on or off"},
{0,1,NULL,"U","ud_analysis",NULL,OPTION_BOOL,&global_options.ud_analysis_set, (void **) &global_options.ud_analysis,{(char *) 0},"Turn ud_analysis on or off"},
{0,0,"Optimization and analysis","Oca","copy_analysis",NULL,OPTION_BOOL,&global_options.copy_analysis_set, (void **) &global_options.copy_analysis,{(char *) 1},"Turn fixpoint copy_analysis on or off"},
{0,0,"Optimization and analysis","Od","dominator_info",NULL,OPTION_BOOL,&global_options.dominator_set, (void **) &global_options.dominator,{(char *) 0},"Turn dominator calculation on or off"},
{0,0,"Optimization and analysis","Os","stack",NULL,OPTION_BOOL,&global_options.stack_set, (void **) &global_options.stack,{(char *) 1},"Turn stack optimization on or off"},
{0,0,"Optimization and analysis","Obe","branch_elimination",NULL,OPTION_BOOL,&global_options.branch_elimination_set, (void **) &global_options.branch_elimination,{(char *) 1},"Turn branch elimination on or off"},
{0,0,"Optimization and analysis","Ocp","copy_propagation",NULL,OPTION_BOOL,&global_options.copy_propagation_set, (void **) &global_options.copy_propagation,{(char *) 1},"Turn copy propagation on or off"},
{0,0,"Optimization and analysis","Op","peepholes",NULL,OPTION_BOOL,&global_options.peephole_set, (void **) &global_options.peephole,{(char *) 1},"Turn peephole optimizations on or off"},
{0,0,"Optimization and analysis","Ols","loadstore",NULL,OPTION_BOOL,&global_options.loadstorefwd_set, (void **) &global_options.loadstorefwd,{(char *) 1},"Turn load-store forwarding on or off"},
{0,0,"Optimization and analysis","Or","remove_unconnected",NULL,OPTION_BOOL,&global_options.remove_unconnected_set, (void **) &global_options.remove_unconnected,{(char *) 1},"Turn removal of unconnected blocks on or off"},
{0,0,"Optimization and analysis","Ol","liveness",NULL,OPTION_BOOL,&global_options.liveness_set, (void **) &global_options.liveness,{(char *) 1},"Turn liveness analysis on or off"},
{0,0,"Optimization and analysis","Oi","inline",NULL,OPTION_BOOL,&global_options.inlining_set, (void **) &global_options.inlining,{(char *) 1},"Turns inlining on or off"},
{0,0,"Optimization and analysis","Oc","constant_propagation",NULL,OPTION_BOOL,&global_options.constant_propagation_set, (void **) &global_options.constant_propagation,{(char *) 1},"Turns constant propagation on or off"},
{0,1,NULL,"Tl","layout_script",NULL,OPTION_FILE,&global_options.layoutscript_set, (void **) &global_options.layoutscript,{NULL},"the layout script to use. if none is given, the default layout script embedded in the linker script will be used"},
{0,1,"File","P","script_prefix",NULL,OPTION_PATH,&global_options.linkerscriptprefix_set, (void **) &global_options.linkerscriptprefix,{NULL},"the path to the directory that holds the linker descriptions"},
{0,1,"File","T","linker_script",NULL,OPTION_FILE,&global_options.linkerscript_set, (void **) &global_options.linkerscript,{NULL},"the linker script to use. if none is given, the default linker script for this architecture will be used"},
{0,1,NULL,"rld","layoutdescription",NULL,OPTION_STRING,&global_options.relayout_description_set, (void **) &global_options.relayout_description,{NULL},"name of the file describing the new layout"},
{0,0,"File","o","output",NULL,OPTION_STRING,&global_options.output_name_set, (void **) &global_options.output_name,{"b.out"},"sets the output filename"},
{0,1,NULL,"Out","output",NULL,OPTION_STRING,&global_options.output_files_set, (void **) &global_options.output_files,{NULL},"sets the output files, separated by ;"},
{0,1,NULL,"In","input",NULL,OPTION_STRING,&global_options.input_files_set, (void **) &global_options.input_files,{NULL},"sets the input files, separated by ;"},
{0,1,NULL,"H",NULL,NULL,OPTION_STRING,&global_options.host_set, (void **) &global_options.host,{NULL},"sets the host on which we will execute"},
{0,1,NULL,"S","strategy",NULL,OPTION_STRING,&global_options.strategy_set, (void **) &global_options.strategy,{"diablo.strategy"},"sets the file from which a strategy will be read"},
{0,0,"File","O","object_path","OBJPATH",OPTION_PATH,&global_options.objpath_set, (void **) &global_options.objpath,{(char *) CONFIG_DEFAULT_OBJPATH},"sets the object-path (i.e. the path where object files linked with the program and the program itself are stored) to <path>"},
{0,0,"File","L","library_path","LIBPATH",OPTION_PATH,&global_options.libpath_set, (void **) &global_options.libpath,{(char *) CONFIG_DEFAULT_LIBPATH},"sets the library-path (i.e. the path where libraries linked with the program are stored, necessary for ADS1.1 development platform, GCC normally uses absolute paths) to <path>"},
{0,0,"Optimization and analysis","Oif","initcfgopt",NULL,OPTION_BOOL,&global_options.initcfgopt_set, (void **) &global_options.initcfgopt,{(char *) 1},"Turns initial unreachable code elimination on or off"},
{0,0,"Phase control","F","flowgraph",NULL,OPTION_BOOL,&global_options.flowgraph_set, (void **) &global_options.flowgraph,{(char *) 1},"Turns flowgraphing on or off"},
{0,0,"Phase control","I","disassemble",NULL,OPTION_BOOL,&global_options.disassemble_set, (void **) &global_options.disassemble,{(char *) 1},"Turns disassembly on or off"},
{0,1,NULL,"R","read",NULL,OPTION_BOOL,&global_options.read_set, (void **) &global_options.read,{(char *) 1},"Turns reading of binaries on or off. Can be used for simply executing a binary"},
{0,0,"Debug","D","generate_dots",NULL,OPTION_BOOL,&global_options.generate_dots_set, (void **) &global_options.generate_dots,{(char *) 0},"Turns printing of dot files on or off"},
{2,0,"Dump","s","restore-multi",NULL,OPTION_INT,&global_options.restore_multi_set, (void **) &global_options.restore_multi,{(char *) -1},"Restore a previous dump, select the number"},
{2,0,"Dump","r","restore",NULL,OPTION_BOOL,&global_options.restore_set, (void **) &global_options.restore,{(char *) 0},"Restore a previous dump"},
{2,0,"Dump","dm","add-dump",NULL,OPTION_BOOL,&global_options.dump_multiple_set, (void **) &global_options.dump_multiple,{(char *) 0},"Dump all information for debugging and add it to an existing dump"},
{2,0,"Dump","d","dump",NULL,OPTION_BOOL,&global_options.dump_set, (void **) &global_options.dump,{(char *) 0},"Dump all information for debugging"},
{1,0,"File",NULL,NULL,NULL,OPTION_STRING,&global_options.objectfilename_set, (void **) &global_options.objectfilename,{NULL},"The binary to optimize. This binary should be accompanied by a map file"},
{0,0,NULL,NULL,NULL,NULL,OPTION_NONE,NULL,NULL,{NULL},NULL}
};
t_global_options global_options;
void OptionsInit()
{
global_options.annotate_loops_set=0;
global_options.print_data_layout_set=0;
global_options.insprofilefile_set=0;
global_options.blockprofilefile_set=0;
global_options.arguments_set=0;
global_options.loop_invariant_code_motion_set=0;
global_options.pre_set=0;
global_options.rely_on_calling_conventions_set=0;
global_options.exec_set=0;
global_options.watermark_set=0;
global_options.stegoFile_set=0;
global_options.stegoDecode_set=0;
global_options.stegoEncode_set=0;
global_options.restoreState_set=0;
global_options.saveState_set=0;
global_options.prepend_set=0;
global_options.fallthrough_set=0;
global_options.figure_set=0;
global_options.bwh_set=0;
global_options.placement_set=0;
global_options.useprofile_set=0;
global_options.makeprofile_set=0;
global_options.gpusage_set=0;
global_options.branchregs2_set=0;
global_options.branchregs_set=0;
global_options.nopscheduler_set=0;
global_options.listscheduler_set=0;
global_options.globalscheduler_set=0;
global_options.mergebbls_set=0;
global_options.gui_output_set=0;
global_options.traceadr_set=0;
global_options.debugcounter_set=0;
global_options.verbose_set=0;
global_options.optimize_set=0;
global_options.ud_analysis_set=0;
global_options.copy_analysis_set=0;
global_options.dominator_set=0;
global_options.stack_set=0;
global_options.branch_elimination_set=0;
global_options.copy_propagation_set=0;
global_options.peephole_set=0;
global_options.loadstorefwd_set=0;
global_options.remove_unconnected_set=0;
global_options.liveness_set=0;
global_options.inlining_set=0;
global_options.constant_propagation_set=0;
global_options.layoutscript_set=0;
global_options.linkerscriptprefix_set=0;
global_options.linkerscript_set=0;
global_options.relayout_description_set=0;
global_options.output_name_set=0;
global_options.output_files_set=0;
global_options.input_files_set=0;
global_options.host_set=0;
global_options.strategy_set=0;
global_options.objpath_set=0;
global_options.libpath_set=0;
global_options.initcfgopt_set=0;
global_options.flowgraph_set=0;
global_options.disassemble_set=0;
global_options.read_set=0;
global_options.generate_dots_set=0;
global_options.restore_multi_set=0;
global_options.restore_set=0;
global_options.dump_multiple_set=0;
global_options.dump_set=0;
global_options.objectfilename_set=0;
}
void OptionsVerify()
{
if (global_options.dump_set||global_options.dump_multiple_set)
if (global_options.restore_multi_set) FATAL(("forbidden option s set"));
if (global_options.dump_set||global_options.dump_multiple_set)
if (global_options.restore_set) FATAL(("forbidden option r set"));
if (global_options.restore_set||global_options.restore_multi_set)
if (global_options.dump_multiple_set) FATAL(("forbidden option dm set"));
if (global_options.restore_set||global_options.restore_multi_set)
if (global_options.dump_set) FATAL(("forbidden option d set"));
if (!(global_options.restore_set||global_options.restore_multi_set))
if (!global_options.objectfilename_set) FATAL(("required option The binary to optimize. This binary should be accompanied by a map file not set"));
}
void OptionsFini()
{
if (global_options.insprofilefile_set) Free(global_options.insprofilefile);
if (global_options.blockprofilefile_set) Free(global_options.blockprofilefile);
if (global_options.arguments_set) Free(global_options.arguments);
if (global_options.watermark_set) Free(global_options.watermark);
if (global_options.stegoFile_set) Free(global_options.stegoFile);
if (global_options.prepend_set) Free(global_options.prepend);
if (global_options.layoutscript_set) Free(global_options.layoutscript);
if (global_options.linkerscriptprefix_set) PathFree(global_options.linkerscriptprefix);
if (global_options.linkerscript_set) Free(global_options.linkerscript);
if (global_options.relayout_description_set) Free(global_options.relayout_description);
if (global_options.output_name_set) Free(global_options.output_name);
if (global_options.output_files_set) Free(global_options.output_files);
if (global_options.input_files_set) Free(global_options.input_files);
if (global_options.host_set) Free(global_options.host);
if (global_options.strategy_set) Free(global_options.strategy);
if (global_options.objpath_set) PathFree(global_options.objpath);
if (global_options.libpath_set) PathFree(global_options.libpath);
if (global_options.objectfilename_set) Free(global_options.objectfilename);
}
