#include "../../config.h"

#ifndef THUMB_ASSEMBLE_ONE_H
#define THUMB_ASSEMBLE_ONE_H
/* Includes {{{ */
#include "../../kernel/diablo_ins.h"
/* }}} */

void ThumbAssembleCondBranch(t_ins * ins, t_uint16 * instr);
void ThumbAssembleBranchLink(t_ins * ins, t_uint32 * instr);
void ThumbAssembleBranch(t_ins * ins, t_uint16 * instr);
void ThumbAssembleSWI(t_ins * ins, t_uint16 * instr);
void ThumbAssemble3Bit(t_ins * ins, t_uint16 * instr);
void ThumbAssembleImm(t_ins * ins, t_uint16 * instr);
void ThumbAssembleShifted(t_ins * ins, t_uint16 * instr);
void ThumbAssembleALU(t_ins * ins, t_uint16 * instr);
void ThumbAssembleHiReg(t_ins * ins, t_uint16 * instr);
void ThumbAssembleLoadAddress(t_ins * ins, t_uint16 * instr);
void ThumbAssembleStack(t_ins * ins, t_uint16 * instr);
void ThumbAssembleTransferImm(t_ins * ins, t_uint16 * instr);
void ThumbAssembleTransferHalf(t_ins * ins, t_uint16 * instr);
void ThumbAssembleTransferSign(t_ins * ins, t_uint16 * instr);
void ThumbAssembleTransferRegOff(t_ins * ins, t_uint16 * instr);
void ThumbAssembleTransferPC(t_ins * ins, t_uint16 * instr);
void ThumbAssembleTransferSP(t_ins * ins, t_uint16 * instr);
void ThumbAssembleMultipleTransfer(t_ins * ins, t_uint16 * instr);
void ThumbAssemblePP(t_ins * ins, t_uint16 * instr);
void ThumbAssembleData(t_ins * ins, t_uint16 * instr);
void ThumbAssembleUnsupported(t_ins * ins, t_uint16 * instr);

#endif
/* vim: set shiftwidth=2 foldmethod=marker : */
