/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../config.h"
#ifndef I386_CONSTANT_PROPAGATION_H
#define I386_CONSTANT_PROPAGATION_H
#include "../../kernel/diablo_flowgraph.h"
#include "../../kernel/diablo_ins.h"
#include "../../kernel/diablo_procstate.h"
void I386EdgePropagator(t_cfg_edge * edge, t_ins * ins);
t_bool I386InstructionUnconditionalizer(t_ins * ins);
t_bool I386InstructionsConstantOptimizer(t_ins * ins, t_procstate * procstate1, t_procstate * procstate2);
#endif
/* vim: set shiftwidth=2: */
