/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../../config.h"
#ifndef IA64_ASSEMBLE_ONE_M_H
#define IA64_ASSEMBLE_ONE_M_H

#include "../../../kernel/diablo_ins.h"
#include "../ia64_bundle.h"
#include "../ia64_assemble.h"

void Ia64AssembleM1(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM2(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM3(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM4(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM5(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM6(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM7(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM8(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM9(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM10(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM11(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM12(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM13(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM14(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM15(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM16(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM17(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM18(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM19(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM20(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM21(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM22(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM23(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM24(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM25(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM26(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM27(t_ins * ins, t_uint64 * instr, t_bundle * bundle); 
void Ia64AssembleM28(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM29(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM30(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM31(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM32(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM33(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM34(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM35(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM36(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM37(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM38(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM39(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM40(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM41(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM42(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM43(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM44(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM45(t_ins * ins, t_uint64 * instr, t_bundle * bundle);
void Ia64AssembleM46(t_ins * ins, t_uint64 * instr, t_bundle * bundle);










#endif
/* vim: set shiftwidth=2: */
