/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../../config.h"
#ifndef IA64_DISASSEMBLE_ONE_I_H
#define IA64_DISASSEMBLE_ONE_I_H

#include "../../../kernel/diablo_ins.h"
#include "../ia64_bundle.h"
#include "../ia64_disassemble.h"

void Ia64DisassembleI1(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI2(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI3(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI4(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI5(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI6(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI7(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI8(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI9(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI10(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI11(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI12(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI13(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI14(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI15(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI16(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI17(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI18(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI19(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI20(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI21(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI22(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI23(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI24(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI25(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI26(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI27(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI28(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleI29(t_ins * ins, t_uint64 instr, t_bundle *bundle);



#endif
/* vim: set shiftwidth=2: */
