/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../../config.h"
#ifndef IA64_DISASSEMBLE_ONE_M_H
#define IA64_DISASSEMBLE_ONE_M_H

#include "../../../kernel/diablo_ins.h"
#include "../ia64_bundle.h"
#include "../ia64_disassemble.h"

void Ia64DisassembleM1(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM2(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM3(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM4(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM5(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM6(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM7(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM8(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM9(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM10(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM11(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM12(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM13(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM14(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM15(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM16(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM17(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM18(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM19(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM20(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM21(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM22(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM23(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM24(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM25(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM26(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM27(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM28(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM29(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM30(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM31(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM32(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM33(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM34(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM35(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM36(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM37(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM38(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM39(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM40(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM41(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM42(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM43(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM44(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM45(t_ins * ins, t_uint64 instr, t_bundle *bundle);
void Ia64DisassembleM46(t_ins * ins, t_uint64 instr, t_bundle *bundle);

#endif
/* vim: set shiftwidth=2: */
