/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../../config.h"
#ifndef IA64_PRINT_F_H
#define IA64_PRINT_F_H

#include "../../../kernel/diablo_ins.h"
#include "../../../datastructures/data_string.h"

void Ia64PrintF1(t_ins * ins, t_string outputstring);
void Ia64PrintF2(t_ins * ins, t_string outputstring);
void Ia64PrintF3(t_ins * ins, t_string outputstring);
void Ia64PrintF4(t_ins * ins, t_string outputstring);
void Ia64PrintF5(t_ins * ins, t_string outputstring);
void Ia64PrintF6(t_ins * ins, t_string outputstring);
void Ia64PrintF7(t_ins * ins, t_string outputstring);
void Ia64PrintF8(t_ins * ins, t_string outputstring);
void Ia64PrintF9(t_ins * ins, t_string outputstring);
void Ia64PrintF10(t_ins * ins, t_string outputstring);
void Ia64PrintF11(t_ins * ins, t_string outputstring);
void Ia64PrintF12(t_ins * ins, t_string outputstring);
void Ia64PrintF13(t_ins * ins, t_string outputstring);
void Ia64PrintF14(t_ins * ins, t_string outputstring);
void Ia64PrintF15(t_ins * ins, t_string outputstring);


#endif
/* vim: set shiftwidth=2: */
