/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "ia64_utils_a.h"
#include "../../../utils/util_error.h"

#include "../ia64_utils.h"
#include "../ia64_instructions.h"
#include "../ia64_registers.h"

#include "../ia64_opcodes.h"



/* TODO: nog alle verborgen gebruikte en gewijzigde registers toevoegen !!!*/



/* A1: Integer Alu-Register-Register */
void Ia64UsedRegistersA1(t_regset * mask, t_ins * ins)
{
  
}

/* A2: Integer Alu-shift left and add */
void Ia64UsedRegistersA2(t_regset * mask, t_ins * ins)
{
  

}


/* A3: Integer Alu-immediate8 register */
void Ia64UsedRegistersA3(t_regset * mask, t_ins * ins)
{
  

}


/* A4: Integer Alu-add immediate14*/
void Ia64UsedRegistersA4(t_regset * mask, t_ins * ins)
{
  

}

/* A5: Integer Alu-add immediate22*/
void Ia64UsedRegistersA5(t_regset * mask, t_ins * ins)
{
  

}

/* A6: Integer compare-register-register*/
void Ia64UsedRegistersA6(t_regset * mask, t_ins * ins)
{
  

}


/* A7: Integer comparetozero-register*/
void Ia64UsedRegistersA7(t_regset * mask, t_ins * ins)
{
  
    
}


/* A8: Integer compare-immediate-register*/
void Ia64UsedRegistersA8(t_regset * mask, t_ins * ins)
{
  

}


/* A9: Multimedia ALU*/
void Ia64UsedRegistersA9(t_regset * mask, t_ins * ins)
{
  

}


/* A10: Multimedia shift and add*/
void Ia64UsedRegistersA10(t_regset * mask, t_ins * ins)
{
  

}


/*----------------------------------------------------------------------------*/



/* A1: Integer Alu-Register-Register */
void Ia64DefinedRegistersA1(t_regset * mask, t_ins * ins)
{
  

}

/* A2: Integer Alu-shift left and add */
void Ia64DefinedRegistersA2(t_regset * mask, t_ins * ins)
{
  

}


/* A3: Integer Alu-immediate8 register */
void Ia64DefinedRegistersA3(t_regset * mask, t_ins * ins)
{
  

}


/* A4: Integer Alu-add immediate14*/
void Ia64DefinedRegistersA4(t_regset * mask, t_ins * ins)
{
  

}

/* A5: Integer Alu-add immediate22*/
void Ia64DefinedRegistersA5(t_regset * mask, t_ins * ins)
{
  

}

/* A6: Integer compare-register-register*/
void Ia64DefinedRegistersA6(t_regset * mask, t_ins * ins)
{


}


/* A7: Integer comparetozero-register*/
void Ia64DefinedRegistersA7(t_regset * mask, t_ins * ins)
{
    

}


/* A8: Integer compare-immediate-register*/
void Ia64DefinedRegistersA8(t_regset * mask, t_ins * ins)
{
  

}


/* A9: Multimedia ALU*/
void Ia64DefinedRegistersA9(t_regset * mask, t_ins * ins)
{


}


/* A10: Multimedia shift and add*/
void Ia64DefinedRegistersA10(t_regset * mask, t_ins * ins)
{


}

/* vim: set shiftwidth=2: */

