/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../../config.h"
#ifndef IA64_UTILS_A_H
#define IA64_UTILS_A_H

#include "../../../kernel/diablo_regset.h"
#include "../../../kernel/diablo_ins.h"

void Ia64UsedRegistersA1(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersA2(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersA3(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersA4(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersA5(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersA6(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersA7(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersA8(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersA9(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersA10(t_regset * mask, t_ins * ins);

void Ia64DefinedRegistersA1(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersA2(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersA3(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersA4(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersA5(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersA6(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersA7(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersA8(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersA9(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersA10(t_regset * mask, t_ins * ins);

#endif
/* vim: set shiftwidth=2: */
