/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../../config.h"
#ifndef IA64_UTILS_F_H
#define IA64_UTILS_F_H

#include "../../../kernel/diablo_regset.h"
#include "../../../kernel/diablo_ins.h"

void Ia64UsedRegistersF1(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF2(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF3(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF4(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF5(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF6(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF7(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF8(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF9(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF10(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF11(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF12(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF13(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF14(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersF15(t_regset * mask, t_ins * ins);


void Ia64DefinedRegistersF1(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF2(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF3(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF4(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF5(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF6(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF7(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF8(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF9(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF10(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF11(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF12(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF13(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF14(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersF15(t_regset * mask, t_ins * ins);

#endif
/* vim: set shiftwidth=2: */
