/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 */
#include "../../../config.h"
#ifndef IA64_UTILS_M_H
#define IA64_UTILS_M_H

#include "../../../kernel/diablo_regset.h"
#include "../../../kernel/diablo_ins.h"

void Ia64UsedRegistersM1(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM2(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM3(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM4(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM5(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM6(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM7(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM8(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM9(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM10(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM11(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM12(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM13(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM14(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM15(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM16(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM17(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM18(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM19(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM20(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM21(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM22(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM23(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM24(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM25(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM26(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM27(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM28(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM29(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM30(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM31(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM32(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM33(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM34(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM35(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM36(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM37(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM38(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM39(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM40(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM41(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM42(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM43(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM44(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM45(t_regset * mask, t_ins * ins);
void Ia64UsedRegistersM46(t_regset * mask, t_ins * ins);

void Ia64DefinedRegistersM1(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM2(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM3(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM4(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM5(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM6(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM7(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM8(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM9(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM10(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM11(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM12(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM13(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM14(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM15(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM16(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM17(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM18(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM19(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM20(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM21(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM22(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM23(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM24(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM25(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM26(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM27(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM28(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM29(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM30(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM31(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM32(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM33(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM34(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM35(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM36(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM37(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM38(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM39(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM40(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM41(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM42(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM43(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM44(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM45(t_regset * mask, t_ins * ins);
void Ia64DefinedRegistersM46(t_regset * mask, t_ins * ins);

#endif
/* vim: set shiftwidth=2: */
