/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *//*!\addtogroup FILE_FORMATS Handling different file formats */
/*@{ */
/*! \defgroup AR Archives */ 
/*@{ */
#ifndef MY_ARCH_H
#define MY_ARCH_H
#define ARMAG   "!<arch>\n"
#define SARMAG  8
#define ARFMAG  "`\n"   
#define ARFZMAG  "Z\n"   
#define COMPRESSED_ALPHA 1
#include "../../datastructures/data_hash.h"
#include "../../kernel/diablo_object.h"
#include "../../kernel/diablo_archives.h"


t_bool IsArchAr(FILE * fp);
t_bool IsArchAlphaAr(FILE * fp);
void ArchArOpen(FILE * fp, t_archive * ar);
void ArchAlphaArOpen(FILE * fp, t_archive * ar);
#endif
/*@}*/
/*@}*/
