#ifndef BISON_DIABLO_LINKER_SCRIPTS_PARSER_H
# define BISON_DIABLO_LINKER_SCRIPTS_PARSER_H

#ifndef YYSTYPE
typedef union 
{
   int number;
   char * string;
   struct {
     char * string;
     int type;
     void * args;
   } arg_and_type;
   void * args;
   t_ast_node * function;
   void * rule;
} yystype;
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif
# define	VARIABLE_DEFINITION	257
# define	VARIABLE_STRING	258
# define	RULE_NAME	259
# define	ACTION	260
# define	TRIGGER	261
# define	SECTION	262
# define	ADDRESS	263
# define	SYMBOL	264
# define	NAME	265
# define	FUNCTION_NAME	266
# define	OPEN_B	267
# define	CLOSE_B	268
# define	BODY_STRING	269
# define	COMMA	270
# define	AND	271
# define	OR	272
# define	ADD	273
# define	SUB	274


extern YYSTYPE LinkerScriptParserlval;

#endif /* not BISON_DIABLO_LINKER_SCRIPTS_PARSER_H */
