#ifndef OPTION_STRUCT
#define OPTION_STRUCT
#include <stdlib.h>
#include "./utils/util_options.h"
typedef struct {
t_bool annotate_loops_set;
t_bool annotate_loops;
t_bool print_data_layout_set;
t_bool print_data_layout;
t_bool insprofilefile_set;
t_string insprofilefile;
t_bool blockprofilefile_set;
t_string blockprofilefile;
t_bool arguments_set;
t_string arguments;
t_bool loop_invariant_code_motion_set;
t_bool loop_invariant_code_motion;
t_bool pre_set;
t_bool pre;
t_bool rely_on_calling_conventions_set;
t_bool rely_on_calling_conventions;
t_bool exec_set;
t_bool exec;
t_bool watermark_set;
t_string watermark;
t_bool stegoFile_set;
t_string stegoFile;
t_bool stegoDecode_set;
t_bool stegoDecode;
t_bool stegoEncode_set;
t_bool stegoEncode;
t_bool restoreState_set;
t_bool restoreState;
t_bool saveState_set;
t_bool saveState;
t_bool prepend_set;
t_string prepend;
t_bool fallthrough_set;
t_bool fallthrough;
t_bool figure_set;
t_bool figure;
t_bool bwh_set;
t_bool bwh;
t_bool placement_set;
t_bool placement;
t_bool useprofile_set;
t_bool useprofile;
t_bool makeprofile_set;
t_bool makeprofile;
t_bool gpusage_set;
t_bool gpusage;
t_bool branchregs2_set;
t_bool branchregs2;
t_bool branchregs_set;
t_bool branchregs;
t_bool nopscheduler_set;
t_bool nopscheduler;
t_bool listscheduler_set;
t_bool listscheduler;
t_bool globalscheduler_set;
t_bool globalscheduler;
t_bool mergebbls_set;
t_bool mergebbls;
t_bool gui_output_set;
t_bool gui_output;
t_bool traceadr_set;
t_int32 traceadr;
t_bool debugcounter_set;
t_int32 debugcounter;
t_bool verbose_set;
t_int32 verbose;
t_bool optimize_set;
t_bool optimize;
t_bool ud_analysis_set;
t_bool ud_analysis;
t_bool copy_analysis_set;
t_bool copy_analysis;
t_bool dominator_set;
t_bool dominator;
t_bool stack_set;
t_bool stack;
t_bool branch_elimination_set;
t_bool branch_elimination;
t_bool copy_propagation_set;
t_bool copy_propagation;
t_bool peephole_set;
t_bool peephole;
t_bool loadstorefwd_set;
t_bool loadstorefwd;
t_bool remove_unconnected_set;
t_bool remove_unconnected;
t_bool liveness_set;
t_bool liveness;
t_bool inlining_set;
t_bool inlining;
t_bool constant_propagation_set;
t_bool constant_propagation;
t_bool layoutscript_set;
t_string layoutscript;
t_bool linkerscriptprefix_set;
t_path * linkerscriptprefix;
t_bool linkerscript_set;
t_string linkerscript;
t_bool relayout_description_set;
t_string relayout_description;
t_bool output_name_set;
t_string output_name;
t_bool output_files_set;
t_string output_files;
t_bool input_files_set;
t_string input_files;
t_bool host_set;
t_string host;
t_bool strategy_set;
t_string strategy;
t_bool objpath_set;
t_path * objpath;
t_bool libpath_set;
t_path * libpath;
t_bool initcfgopt_set;
t_bool initcfgopt;
t_bool flowgraph_set;
t_bool flowgraph;
t_bool disassemble_set;
t_bool disassemble;
t_bool read_set;
t_bool read;
t_bool generate_dots_set;
t_bool generate_dots;
t_bool restore_multi_set;
t_int32 restore_multi;
t_bool restore_set;
t_bool restore;
t_bool dump_multiple_set;
t_bool dump_multiple;
t_bool dump_set;
t_bool dump;
t_bool objectfilename_set;
t_string objectfilename;
} t_global_options;
extern t_global_options global_options;
void OptionsInit();
void OptionsVerify();
void OptionsDefaults();
#endif
