#ifndef UTIL_BITMANIPULATION_H
#define UTIL_BITMANIPULATION_H
#define BitRotateRight(x,r)	( (( (x) << (32 - (r) )) | ( (x) >> (r) )) & 0xffffffff )
#define rotate_right(x,r)       ( (( (x) << (32 - (r) )) | ( (x) >> (r) )) & 0xffffffff )
#define BitRotateLeft(x,r)	( (( (x) >> (32 - (r) )) | ( (x) << (r) )) & 0xffffffff )
#define rotate_left(v, n)       (((v) << (n)) | ((t_uint32)(v))>>(((t_uint32)(32-(n)))))
#define BitSignExtend(x,p)	(((x) ^ (1 << (p))) - (1 << (p))) 
#define BIT_IS_SET(reg,bitnr) ((reg >> bitnr) & 0x1)
#endif
