/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *//* interface for my_machine:
 *
 * This defines everything we need to know about the machine. 
 * All exported type sizes are checked, if PARANOID is defined 
 */

#ifndef MY_MACHINE_H
#define MY_MACHINE_H
#include "../simple_types.h"
typedef enum { LSB, MSB } my_byteorder;
typedef struct
{
   my_byteorder endian; /* Machine endianness */
} my_machineinfo;

extern my_machineinfo global_machine_info;
void MachineInit(void);
t_bool MachineIsAlphaOrIntel(void);
#endif
