/*
 * Copyright 2001,2002: Bruno De Bus
 *                      Bjorn De Sutter
 *                      Dominique Chanet
 *                      Ludo Van Put
 *
 *
 * This file is part of Diablo (Diablo is a better link-time optimizer)
 *
 * Diablo is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * Diablo is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with Diablo; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 *
 *//* $Header: /home/cvs/cvsroot/diablo/utils/util_timer.h,v 1.1.1.1 2003/10/10 12:12:23 bdebus Exp $ */
#ifndef MY_TIMER_H
#define MY_TIMER_H
#include "../datastructures/data_dll.h"
typedef void (*timer_callback)(void *); 
typedef struct _timevals
{ 
    dll list;
    long usecs;
    timer_callback cb;
    void * data;
} timevals;


timevals * TimerAdd(int usecs,int mode,timer_callback cb,void * data);
void DeleteTimer(timevals * delete_me);
void TimerInit();
#endif
